- Main Page
- Namespaces
- Classes
- Files

- Alphabetical List
- Class List
- Class Hierarchy
- Class Members

# Weak1::ARC4_Base Class Reference

`#include <arc4.h>`

Inheritance diagram for Weak1::ARC4_Base:

List of all members.

## Detailed Description

_

Definition at line 11 of file arc4.h.

## Public Types
typedef SymmetricCipherFinal< ARC4_Base > | Encryption
| implements the SymmetricCipher interface
typedef SymmetricCipherFinal< ARC4_Base > | Decryption
| implements the SymmetricCipher interface
enum | IV_Requirement { UNIQUE_IV = 0, RANDOM_IV, UNPREDICTABLE_RANDOM_IV, INTERNALLY_GENERATED_IV, NOT_RESYNCHRONIZABLE }
## Public Member Functions
| ~ARC4_Base ()
void | GenerateBlock (byte *output, size_t size)
| generate random array of bytes
void | DiscardBytes (size_t n)
| generate and discard n bytes
void | ProcessData (byte *outString, const byte *inString, size_t length)
| encrypt or decrypt an array of bytes of specified length
bool | IsRandomAccess () const
| returns whether this cipher supports random access
bool | IsSelfInverting () const
| returns whether this transformation is self-inverting (e.g. xor with a keystream)
bool | IsForwardTransformation () const
| returns whether this is an encryption object
virtual void | IncorporateEntropy (const byte *input, size_t length)
| update RNG state with additional unpredictable values
virtual bool | CanIncorporateEntropy () const
| returns true if IncorporateEntropy is implemented
virtual byte | GenerateByte ()
| generate new random byte and return it
virtual unsigned int | GenerateBit ()
| generate new random bit and return it
virtual word32 | GenerateWord32 (word32 a=0, word32 b=0xffffffffL)
| generate a random 32 bit word in the range min to max, inclusive
virtual void | GenerateIntoBufferedTransformation (BufferedTransformation &target, const std::string &channel, lword length)
| generate random bytes as input to a BufferedTransformation
template<class IT>
void | Shuffle (IT begin, IT end)
| randomly shuffle the specified array, resulting permutation is uniformly distributed
virtual std::string | AlgorithmName () const
| returns name of this algorithm, not universally implemented yet
virtual Clonable * | Clone () const
| this is not implemented by most classes yet
StreamTransformation & | Ref ()
| return a reference to this object,
virtual unsigned int | MandatoryBlockSize () const
| returns block size, if input must be processed in blocks, otherwise 1
virtual unsigned int | OptimalBlockSize () const
| returns the input block size that is most efficient for this cipher
virtual unsigned int | GetOptimalBlockSizeUsed () const
| returns how much of the current block is used up
virtual unsigned int | OptimalDataAlignment () const
| returns how input should be aligned for optimal performance
virtual void | ProcessLastBlock (byte *outString, const byte *inString, size_t length)
| for ciphers where the last block of data is special, encrypt or decrypt the last block of data
virtual unsigned int | MinLastBlockSize () const
| returns the minimum size of the last block, 0 indicating the last block is not special
void | ProcessString (byte *inoutString, size_t length)
| same as ProcessData(inoutString, inoutString, length)
void | ProcessString (byte *outString, const byte *inString, size_t length)
| same as ProcessData(outString, inString, length)
byte | ProcessByte (byte input)
| implemented as {ProcessData(&input, &input, 1); return input;}
virtual void | Seek (lword n)
| for random access ciphers, seek to an absolute position
virtual size_t | MinKeyLength () const=0
| returns smallest valid key length in bytes */
virtual size_t | MaxKeyLength () const=0
| returns largest valid key length in bytes */
virtual size_t | DefaultKeyLength () const=0
| returns default (recommended) key length in bytes */
virtual size_t | GetValidKeyLength (size_t n) const=0
| returns the smallest valid key length in bytes that is >= min(n, GetMaxKeyLength())
virtual bool | IsValidKeyLength (size_t n) const
| returns whether n is a valid key length
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| set or reset the key of this object
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| calls SetKey() with an NameValuePairs object that just specifies "Rounds"
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| calls SetKey() with an NameValuePairs object that just specifies "IV"
virtual IV_Requirement | IVRequirement () const=0
| returns the minimal requirement for secure IVs
bool | IsResynchronizable () const
| returns whether this object can be resynchronized (i.e. supports initialization vectors)
bool | CanUseRandomIVs () const
| returns whether this object can use random IVs (in addition to ones returned by GetNextIV)
bool | CanUsePredictableIVs () const
| returns whether this object can use random but possibly predictable IVs (in addition to ones returned by GetNextIV)
bool | CanUseStructuredIVs () const
| returns whether this object can use structured IVs, for example a counter (in addition to ones returned by GetNextIV)
virtual unsigned int | IVSize () const
| returns size of IVs used by this object
virtual void | Resynchronize (const byte *IV)
| resynchronize with an IV
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *IV)
| get a secure IV for the next message
## Static Public Member Functions
static const char * | StaticAlgorithmName ()
static size_t __cdecl | StaticGetValidKeyLength (size_t n)
## Static Public Attributes
static const int | MIN_KEYLENGTH
static const int | MAX_KEYLENGTH
static const int | DEFAULT_KEYLENGTH
static const int | KEYLENGTH_MULTIPLE
static const int | IV_REQUIREMENT
static const int | IV_LENGTH
## Protected Member Functions
void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)
virtual unsigned int | GetDefaultDiscardBytes () const
virtual const Algorithm & | GetAlgorithm () const=0
void | ThrowIfInvalidKeyLength (size_t length)
void | ThrowIfResynchronizable ()
void | ThrowIfInvalidIV (const byte *iv)
const byte * | GetIVAndThrowIfInvalid (const NameValuePairs &params)
void | AssertValidKeyLength (size_t length) const
## Protected Attributes
FixedSizeSecBlock< byte, 256 > | m_state
byte | m_x
byte | m_y

## Member Enumeration Documentation

enum SimpleKeyingInterface::IV_Requirement`[inherited]`

Enumerator:

  UNIQUE_IV |
  RANDOM_IV |
  UNPREDICTABLE_RANDOM_IV |
  INTERNALLY_GENERATED_IV |
  NOT_RESYNCHRONIZABLE |

Definition at line 382 of file cryptlib.h.

## Member Function Documentation

void ARC4_Base::ProcessData | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length |
| ) |  |  | `[virtual]`

encrypt or decrypt an array of bytes of specified length

Note:
  either inString == outString, or they don't overlap

Implements StreamTransformation.

Definition at line 71 of file arc4.cpp.

References m_state, m_x, and m_y.

unsigned int RandomNumberGenerator::GenerateBit | ( |  | ) | `[virtual, inherited]`

generate new random bit and return it

Default implementation is to call GenerateByte() and return its lowest bit.

Reimplemented in PublicBlumBlumShub.

Definition at line 129 of file cryptlib.cpp.

References RandomNumberGenerator::GenerateByte().

Referenced by XTR_FindPrimesAndGenerator().

StreamTransformation& StreamTransformation::Ref | ( |  | ) | `[inline, inherited]`

return a reference to this object,

This function is useful for passing a temporary StreamTransformation object to a function that takes a non-const reference.

Definition at line 470 of file cryptlib.h.

virtual unsigned int StreamTransformation::OptimalBlockSize | ( |  | ) | const`[inline, virtual, inherited]`

returns the input block size that is most efficient for this cipher

Note:
  optimal input length is n * OptimalBlockSize() - GetOptimalBlockSizeUsed() for any n > 0

Reimplemented in ECB_OneWay.

Definition at line 477 of file cryptlib.h.

Referenced by StreamTransformationFilter::FirstPut().

void StreamTransformation::ProcessLastBlock | ( | byte * | outString,
|  | const byte * | inString,
|  | size_t | length |
| ) |  |  | `[virtual, inherited]`

for ciphers where the last block of data is special, encrypt or decrypt the last block of data

For now the only use of this function is for CBC-CTS mode.

Reimplemented in CBC_CTS_Encryption, and CBC_CTS_Decryption.

Definition at line 119 of file cryptlib.cpp.

References StreamTransformation::MandatoryBlockSize(), StreamTransformation::MinLastBlockSize(), and StreamTransformation::ProcessData().

Referenced by StreamTransformationFilter::LastPut().

void SimpleKeyingInterface::SetKey | ( | const byte * | key,
|  | size_t | length,
|  | const NameValuePairs & | params = `g_nullNameValuePairs` |
| ) |  |  | `[virtual, inherited]`

set or reset the key of this object

Parameters:

  | params | is used to specify Rounds, BlockSize, etc

Reimplemented in ECB_OneWay.

Definition at line 52 of file cryptlib.cpp.

References SimpleKeyingInterface::ThrowIfInvalidKeyLength().

Referenced by CBC_MAC< T >::CBC_MAC(), CipherModeFinalTemplate_CipherHolder< CIPHER, BASE >::CipherModeFinalTemplate_CipherHolder(), DMAC< T >::DMAC(), HMAC< T >::HMAC(), Weak::PanamaMAC< B >::PanamaMAC(), ECB_OneWay::SetKey(), SimpleKeyingInterface::SetKeyWithIV(), SimpleKeyingInterface::SetKeyWithRounds(), VMAC_Base::UncheckedSetKey(), and BlockOrientedCipherModeBase::UncheckedSetKey().

bool SimpleKeyingInterface::IsResynchronizable | ( |  | ) | const`[inline, inherited]`

returns whether this object can be resynchronized (i.e. supports initialization vectors)

If this function returns true, and no IV is passed to SetKey() and CanUseStructuredIVs()==true, an IV of all 0's will be assumed.

Definition at line 388 of file cryptlib.h.

Referenced by SimpleKeyingInterface::ThrowIfInvalidIV(), SimpleKeyingInterface::ThrowIfResynchronizable(), and BlockOrientedCipherModeBase::UncheckedSetKey().

void SimpleKeyingInterface::GetNextIV | ( | RandomNumberGenerator & | rng,
|  | byte * | IV |
| ) |  |  | `[virtual, inherited]`

get a secure IV for the next message

This method should be called after you finish encrypting one message and are ready to start the next one. After calling it, you must call SetKey() or Resynchronize() before using this object again. This method is not implemented on decryption objects.

Reimplemented in VMAC_Base.

Definition at line 96 of file cryptlib.cpp.

References RandomNumberGenerator::GenerateBlock(), and SimpleKeyingInterface::IVSize().

Referenced by VMAC_Base::GetNextIV().

The documentation for this class was generated from the following files:

- arc4.h
- arc4.cpp